signature RASTERFONT =
sig
    type surface
    type font
    val newfont : {w:int, h:int, firstchar:int, charperrow:int, pixels:surface} -> font
    val blitstring : font * surface * int * int * string -> unit
end

functor RasterFont(structure Sdl : SDL) :>
	RASTERFONT where type surface = Sdl.surface  =
struct
type surface = Sdl.surface
  type font = {w:int, h:int, firstchar:int, charperrow:int, pixels:Sdl.surface}
  fun newfont x = x
  fun blitstring ({w,h,firstchar,charperrow,pixels}, sf, x, y, s) = 
      let
	  fun go [] cx cy = ()
	    | go (c::tl) cx cy = 
	      let val code = ord c  in
		  if code >= firstchar then
		      let
			  val u = (code - firstchar) mod charperrow
			  val v = (code - firstchar) div charperrow
		      in
			  Sdl.blit(pixels, sf, u * w, v * h, w, h, cx * w + x, cy * h + y);
			  go tl (cx+1)cy
		      end
		  else if code = ord #"\n" then go tl 0 (cy+1)
		  else go tl cx cy
	      end
      in
	  go (explode s) 0 0
      end
end
